<?php
namespace Folha\Repositories;

class GpeOcupacaom extends \Doctrine\ORM\EntityRepository
{
    public function getAllOcupacoes($dtCompetencia, $nrOrg)
    {
        $sql = "SELECT GPE_OCUPACAOM.NROCUPACAOM, GPE_OCUPACAOH.NMOCUPACAOH,
                       GPE_OCUPACAOM.NRORG, GPE_OCUPACAOM.NRTIPOOCUPACAO,
                       GPE_OCUPACAOM.DTINIVIGENCIA,  GPE_OCUPACAOM.DTFIMVIGENCIA
                  FROM GPE_OCUPACAOM
            INNER JOIN GPE_OCUPACAOH
                    ON GPE_OCUPACAOM.NROCUPACAOM = GPE_OCUPACAOH.NROCUPACAOM
                   AND GPE_OCUPACAOM.NRORG       = GPE_OCUPACAOH.NRORG
            INNER JOIN (SELECT MAX(CH.DTMESCOMPETENC) AS DTCOMPETENC,
                               CH.NROCUPACAOM, CH.NRORG
                          FROM GPE_OCUPACAOH CH
                         WHERE DTMESCOMPETENC <= :P_DTCOMPETENC
                      GROUP BY CH.NROCUPACAOM, CH.NRORG
                       ) CHA
                    ON CHA.NROCUPACAOM = GPE_OCUPACAOM.NROCUPACAOM
                   AND CHA.DTCOMPETENC = GPE_OCUPACAOH.DTMESCOMPETENC
                   AND CHA.NRORG       = GPE_OCUPACAOM.NRORG
                   AND GPE_OCUPACAOM.NRORG = :P_NRORG
              ORDER BY NMOCUPACAOH";

        $params = array(
            "P_DTCOMPETENC" => $dtCompetencia,
            "P_NRORG"       => $nrOrg
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

}