package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.NutrientesProdutoFlows;
import com.javaseleniumtemplate.pages.NutrientesProdutoPage;
import org.testng.annotations.Test;

public class NutrientesProdutoTests extends TestBase {

    NutrientesProdutoPage nutrientesProdutoPage;
    NutrientesProdutoFlows nutrientesProdutoFlows;
    LoginFlows loginFlows;

    //adicionar, editar e excluir o nutriente em um produto
    @Test
    public void adicionarNutri() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.adicionar();
        nutrientesProdutoPage.editar();
        nutrientesProdutoPage.excluir();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //gerar o relatório 'Nutrientes por Produto'
    @Test
    public void relatorioNutrientes() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto");

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //gerar o relatório 'Nutriente por Produto (Ordem Crescente)'
    @Test
    public void relatorioCrescente() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Crescente)");

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //gerar o relatório 'Nutrientes por Produto (Ordem Decrescente)'
    @Test
    public void relatorioDecrescente() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.relatorio("Nutrientes por Produto (Ordem Decrescente)");

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    //verificar os campo obrigatórios
    //selecionar 2 nutrientes e verificar se os mesmos aparecem no campo de nutrientes
    //verificar o click no radio button da ordenação por código e alfabética.
    //verificar os níveis do 0 ao 5 da ordem alfabética
    @Test
    public void verificarCamposRelatorio() {
        nutrientesProdutoPage = new NutrientesProdutoPage();
        nutrientesProdutoFlows = new NutrientesProdutoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        nutrientesProdutoFlows.navegateTelaNutrientesProd();
        nutrientesProdutoPage.verificarCamposObrigatorios();
        nutrientesProdutoPage.refresh();
        nutrientesProdutoPage.verificarCampoNutriente();
        nutrientesProdutoPage.verificarOrdenacao();
        nutrientesProdutoPage.verificarCampoNivel();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

}
