package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PadraoCicloFlows;
import com.javaseleniumtemplate.pages.PadraoCicloPage;
import org.testng.annotations.Test;

public class PadraoCicloTests extends TestBase {

    PadraoCicloPage padraoCicloPage;
    PadraoCicloFlows padraoCicloFlows;
    LoginFlows loginFlows;

    //adicionar um novo padrão de ciclo e verificar o código e nome do novo padrão
    //editar nome do padrão adicionar e verificar o nome salvo
    //excluir o padrão de ciclo adicionado
    @Test
    public void padraoCiclo() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.adicionarPadrao();
        padraoCicloPage.verificarPadraoCicloAdd();
        padraoCicloPage.editarPadraoClico();
        padraoCicloPage.excluirPadraoCiclo();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //verificar campo obrigatórios
    //tentar excluir um padrão de ciclo que possuí registro filho
    //adicionar um novo padrão e tentar excluí-lo juntamente com outro padrão que possui registro filho.
    //Isso não deve ser permitido porque um deles possui registro filho
    //excluir o padrão de ciclo adicionado
    //tentar adicionar um padrão de ciclo com código já cadastrado e verificar a mensagem que é exibida na tela
    @Test
    public void testarCampos() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.verificarCamposObrigatorios();
        padraoCicloPage.tentarExcluirPadraoComRegFilho();
        padraoCicloPage.adicionarPadrao();
        padraoCicloPage.tentarExcluriDoisPadroes();
        padraoCicloPage.excluirPadraoCiclo();
        padraoCicloPage.tentarAddPadraoComCodigoExistente();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
